//+------------------------------------------------------------------+
//|                                                ColorTrend_CF.mq5 |
//|                                         CF = Continuation Factor |
//|               Converted by and Copyright: Ronald Verwer/ROVERCOM |
//|                                                         27/04/06 |
//+------------------------------------------------------------------+
//----  
#property copyright "Converted by and Copyright: Ronald Verwer/ROVERCOM"
#property link ""
//----   
#property version   "1.01"
//----     
#property indicator_separate_window 
//----        
#property indicator_buffers 2
//----  1  
#property indicator_plots   1
//+----------------------------------------------+
//|                     |
//+----------------------------------------------+
//----        
#property indicator_type1   DRAW_FILLING
//----       MediumSeaGreen  DeepPink
#property indicator_color1  clrMediumSeaGreen, clrDeepPink
//----   
#property indicator_label1 "Trend_CF"
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint Period_=30;
//+----------------------------------------------+
//----   ,    
//----      
double UpperBuffer[];
double LowerBuffer[];
//----
int Count[];
//----      
int StartBar;
//----      
double x_p[],x_n[],y_p[],y_n[];
//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+   
void Recount_ArrayZeroPos(int &CoArr[]//        
                          )
  {
//----
   int numb;
   static int count=1;
   count--;
   if(count<0) count=int(Period_)-1;
//----
   for(int iii=0; iii<int(Period_); iii++)
     {
      numb=iii+count;
      if(numb>int(Period_)-1) numb-=int(Period_);
      CoArr[iii]=numb;
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----  
   StartBar=int(Period_);
//----        
   ArrayResize(x_p,Period_);
   ArrayResize(x_n,Period_);
   ArrayResize(y_p,Period_);
   ArrayResize(y_n,Period_);
   ArrayResize(Count,Period_);
//----      
   SetIndexBuffer(0,UpperBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,StartBar);
//----      
   SetIndexBuffer(1,LowerBuffer,INDICATOR_DATA);
//----      
   string shortname;
   StringConcatenate(shortname,"Trend_CF(",Period_,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[])    //     
  {
//----       
   if(rates_total<StartBar+begin) return(0);
//----    
   int first,bar,bar0,bar1,barq;
   double chp,chn,cffp,cffn,dprice;
//----    first    
   if(prev_calculated==0) //      
      first=1+begin; //      
   else first=prev_calculated-1; //      
//----    
   for(bar=first; bar<rates_total; bar++)
     {
      dprice=price[bar]-price[bar-1];
      //----
      bar0=Count[0];
      bar1=Count[1];
      //----
      if(dprice>0)
        {
         x_p[bar0]=dprice;
         y_p[bar0]=x_p[bar0]+y_p[bar1];
         x_n[bar0]=0;
         y_n[bar0]=0;
        }
      else
        {
         x_n[bar0]=-dprice;
         y_n[bar0]=x_n[bar0]+y_n[bar1];
         x_p[bar0]=0;
         y_p[bar0]=0;
        }
      //----
      if(bar<StartBar+begin)
        {
         if(bar<rates_total-1) Recount_ArrayZeroPos(Count);
         continue;
        }
      //----
      chp=0;
      chn=0;
      cffp=0;
      cffn=0;
      //----
      for(int q=int(Period_)-1; q>=0; q--)
        {
         barq=Count[q];

         chp+=x_p[barq];
         chn+=x_n[barq];
         cffp+=y_p[barq];
         cffn+=y_n[barq];
        }
      //----
      UpperBuffer[bar]=(chp-cffn)/_Point;
      LowerBuffer[bar]=(chn-cffp)/_Point;
      //----
      if(bar<rates_total-1) Recount_ArrayZeroPos(Count);
     }
//----    
   return(rates_total);
  }
//+------------------------------------------------------------------+
